blob: 868e18b9a1ab85ae093da936558d394b37059215 [file] [log] [blame]
Dmitry Marakasov6912ea92013-05-21 00:24:34 +04001#!/bin/sh
Avery Pennarun0ca71b32009-04-24 14:13:34 -04002#
3# git-subtree.sh: split/join git repositories in subdirectories of this one
4#
Avery Pennarunb77172f2009-04-24 15:48:41 -04005# Copyright (C) 2009 Avery Pennarun <apenwarr@gmail.com>
Avery Pennarun0ca71b32009-04-24 14:13:34 -04006#
David Aguilar6ae6a232016-07-27 17:16:49 -07007if test $# -eq 0
8then
9 set -- -h
Avery Pennarun96db2c02009-04-24 22:36:06 -040010fi
Avery Pennarun0ca71b32009-04-24 14:13:34 -040011OPTS_SPEC="\
Avery Pennarunf4f29552009-05-30 01:10:14 -040012git subtree add --prefix=<prefix> <commit>
Anthony Baire1c3e0f02013-11-27 19:34:09 +010013git subtree add --prefix=<prefix> <repository> <ref>
Avery Pennarun13648af2009-04-24 23:41:19 -040014git subtree merge --prefix=<prefix> <commit>
Anthony Baire1c3e0f02013-11-27 19:34:09 +010015git subtree pull --prefix=<prefix> <repository> <ref>
16git subtree push --prefix=<prefix> <repository> <ref>
Denton Liu77128ed2019-03-11 02:47:17 -070017git subtree split --prefix=<prefix> <commit>
Avery Pennarun0ca71b32009-04-24 14:13:34 -040018--
Avery Pennarun96db2c02009-04-24 22:36:06 -040019h,help show the help
20q quiet
Avery Pennarun942dce52009-04-26 18:06:08 -040021d show debug messages
Jakub Suder6e25f792010-01-12 22:38:21 +010022P,prefix= the name of the subdir to split out
Jakub Suder2da09692010-01-09 19:55:35 +010023m,message= use the given message as the commit message for the merge commit
Avery Pennarun13648af2009-04-24 23:41:19 -040024 options for 'split'
Avery Pennarund0eb1b12009-04-26 08:59:12 -040025annotate= add a prefix to commit message of new commits
Avery Pennarun43a39512009-05-30 01:05:43 -040026b,branch= create a new branch from the split subtree
27ignore-joins ignore prior --rejoin commits
Avery Pennarun96db2c02009-04-24 22:36:06 -040028onto= try connecting new tree to an existing one
29rejoin merge the new branch back into HEAD
Danny Lin6ccc71a2015-05-07 15:52:33 +080030 options for 'add', 'merge', and 'pull'
Avery Pennarun8e790432009-05-30 00:48:07 -040031squash merge subtree changes as a single commit
Avery Pennarun0ca71b32009-04-24 14:13:34 -040032"
Cole Stanfield11f15112010-09-13 13:16:57 -060033eval "$(echo "$OPTS_SPEC" | git rev-parse --parseopt -- "$@" || echo exit $?)"
Avery Pennarun9c632ea2010-06-24 01:53:05 -040034
Avery Pennarundf2302d2010-06-24 16:57:58 -040035PATH=$PATH:$(git --exec-path)
Avery Pennarun33aaa692009-08-26 10:41:03 -040036. git-sh-setup
Avery Pennarun9c632ea2010-06-24 01:53:05 -040037
Avery Pennarun0ca71b32009-04-24 14:13:34 -040038require_work_tree
39
40quiet=
Avery Pennarun43a39512009-05-30 01:05:43 -040041branch=
Avery Pennarun942dce52009-04-26 18:06:08 -040042debug=
Avery Pennarun0ca71b32009-04-24 14:13:34 -040043command=
Avery Pennarunb77172f2009-04-24 15:48:41 -040044onto=
45rejoin=
Avery Pennarun96db2c02009-04-24 22:36:06 -040046ignore_joins=
Avery Pennarund0eb1b12009-04-26 08:59:12 -040047annotate=
Avery Pennarun8e790432009-05-30 00:48:07 -040048squash=
Jakub Suder2da09692010-01-09 19:55:35 +010049message=
Jeff Kingcba5e282014-03-17 15:59:47 -040050prefix=
Avery Pennarun0ca71b32009-04-24 14:13:34 -040051
David Aguilard7fd7922016-07-27 17:16:50 -070052debug () {
David Aguilar6ae6a232016-07-27 17:16:49 -070053 if test -n "$debug"
54 then
Danny Lin2ded1092015-05-08 08:56:59 +080055 printf "%s\n" "$*" >&2
Avery Pennarun942dce52009-04-26 18:06:08 -040056 fi
57}
58
David Aguilard7fd7922016-07-27 17:16:50 -070059say () {
David Aguilar6ae6a232016-07-27 17:16:49 -070060 if test -z "$quiet"
61 then
Danny Lin2ded1092015-05-08 08:56:59 +080062 printf "%s\n" "$*" >&2
63 fi
64}
65
David Aguilard7fd7922016-07-27 17:16:50 -070066progress () {
David Aguilar6ae6a232016-07-27 17:16:49 -070067 if test -z "$quiet"
68 then
Danny Lin2ded1092015-05-08 08:56:59 +080069 printf "%s\r" "$*" >&2
Avery Pennarun0ca71b32009-04-24 14:13:34 -040070 fi
71}
72
David Aguilard7fd7922016-07-27 17:16:50 -070073assert () {
David Aguilar6ae6a232016-07-27 17:16:49 -070074 if ! "$@"
75 then
Avery Pennarun25733542009-04-24 14:24:38 -040076 die "assertion failed: " "$@"
77 fi
78}
79
Denton Liu77128ed2019-03-11 02:47:17 -070080ensure_single_rev () {
81 if test $# -ne 1
82 then
83 die "You must provide exactly one revision. Got: '$@'"
84 fi
85}
Avery Pennarun25733542009-04-24 14:24:38 -040086
David Aguilar6ae6a232016-07-27 17:16:49 -070087while test $# -gt 0
88do
Avery Pennarun0ca71b32009-04-24 14:13:34 -040089 opt="$1"
90 shift
David Aguilar6ae6a232016-07-27 17:16:49 -070091
Avery Pennarun0ca71b32009-04-24 14:13:34 -040092 case "$opt" in
David Aguilar6ae6a232016-07-27 17:16:49 -070093 -q)
94 quiet=1
95 ;;
96 -d)
97 debug=1
98 ;;
99 --annotate)
100 annotate="$1"
101 shift
102 ;;
103 --no-annotate)
104 annotate=
105 ;;
106 -b)
107 branch="$1"
108 shift
109 ;;
110 -P)
111 prefix="${1%/}"
112 shift
113 ;;
114 -m)
115 message="$1"
116 shift
117 ;;
118 --no-prefix)
119 prefix=
120 ;;
121 --onto)
122 onto="$1"
123 shift
124 ;;
125 --no-onto)
126 onto=
127 ;;
128 --rejoin)
129 rejoin=1
130 ;;
131 --no-rejoin)
132 rejoin=
133 ;;
134 --ignore-joins)
135 ignore_joins=1
136 ;;
137 --no-ignore-joins)
138 ignore_joins=
139 ;;
140 --squash)
141 squash=1
142 ;;
143 --no-squash)
144 squash=
145 ;;
146 --)
147 break
148 ;;
149 *)
150 die "Unexpected option: $opt"
151 ;;
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400152 esac
153done
154
155command="$1"
156shift
David Aguilar6ae6a232016-07-27 17:16:49 -0700157
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400158case "$command" in
David Aguilar6ae6a232016-07-27 17:16:49 -0700159add|merge|pull)
160 default=
161 ;;
162split|push)
163 default="--default HEAD"
164 ;;
165*)
166 die "Unknown command '$command'"
167 ;;
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400168esac
169
David Aguilar6ae6a232016-07-27 17:16:49 -0700170if test -z "$prefix"
171then
Avery Pennarun9a8821f2009-04-24 22:57:14 -0400172 die "You must provide the --prefix option."
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400173fi
Win Treeseec54f0d2010-02-05 22:02:43 -0500174
Avery Pennarun77ba3052010-02-08 15:00:42 -0500175case "$command" in
David Aguilar6ae6a232016-07-27 17:16:49 -0700176add)
177 test -e "$prefix" &&
178 die "prefix '$prefix' already exists."
179 ;;
180*)
181 test -e "$prefix" ||
182 die "'$prefix' does not exist; use 'git subtree add'"
183 ;;
Avery Pennarun77ba3052010-02-08 15:00:42 -0500184esac
Win Treeseec54f0d2010-02-05 22:02:43 -0500185
Avery Pennarun6f2012c2009-10-02 15:22:15 -0400186dir="$(dirname "$prefix/.")"
Avery Pennarun9a8821f2009-04-24 22:57:14 -0400187
David Aguilar6ae6a232016-07-27 17:16:49 -0700188if test "$command" != "pull" &&
189 test "$command" != "add" &&
190 test "$command" != "push"
191then
Avery Pennarun13648af2009-04-24 23:41:19 -0400192 revs=$(git rev-parse $default --revs-only "$@") || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700193 dirs=$(git rev-parse --no-revs --no-flags "$@") || exit $?
Denton Liu77128ed2019-03-11 02:47:17 -0700194 ensure_single_rev $revs
David Aguilar6ae6a232016-07-27 17:16:49 -0700195 if test -n "$dirs"
196 then
Avery Pennarun13648af2009-04-24 23:41:19 -0400197 die "Error: Use --prefix instead of bare filenames."
198 fi
Avery Pennarun9a8821f2009-04-24 22:57:14 -0400199fi
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400200
201debug "command: {$command}"
202debug "quiet: {$quiet}"
203debug "revs: {$revs}"
204debug "dir: {$dir}"
Avery Pennarun13648af2009-04-24 23:41:19 -0400205debug "opts: {$*}"
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400206debug
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400207
David Aguilard7fd7922016-07-27 17:16:50 -0700208cache_setup () {
Avery Pennarun25733542009-04-24 14:24:38 -0400209 cachedir="$GIT_DIR/subtree-cache/$$"
David Aguilar6ae6a232016-07-27 17:16:49 -0700210 rm -rf "$cachedir" ||
211 die "Can't delete old cachedir: $cachedir"
212 mkdir -p "$cachedir" ||
213 die "Can't create new cachedir: $cachedir"
214 mkdir -p "$cachedir/notree" ||
215 die "Can't create new cachedir: $cachedir/notree"
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400216 debug "Using cachedir: $cachedir" >&2
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400217}
218
David Aguilard7fd7922016-07-27 17:16:50 -0700219cache_get () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700220 for oldrev in "$@"
221 do
222 if test -r "$cachedir/$oldrev"
223 then
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400224 read newrev <"$cachedir/$oldrev"
225 echo $newrev
226 fi
227 done
228}
229
David Aguilard7fd7922016-07-27 17:16:50 -0700230cache_miss () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700231 for oldrev in "$@"
232 do
233 if ! test -r "$cachedir/$oldrev"
234 then
Jesse Greenwald915b9892010-11-09 22:18:36 -0600235 echo $oldrev
236 fi
237 done
238}
239
David Aguilard7fd7922016-07-27 17:16:50 -0700240check_parents () {
Strain, Roger L315a84f2018-09-28 13:35:39 -0500241 missed=$(cache_miss "$1")
242 local indent=$(($2 + 1))
David Aguilar6ae6a232016-07-27 17:16:49 -0700243 for miss in $missed
244 do
245 if ! test -r "$cachedir/notree/$miss"
246 then
Jesse Greenwald915b9892010-11-09 22:18:36 -0600247 debug " incorrect order: $miss"
Strain, Roger L315a84f2018-09-28 13:35:39 -0500248 process_split_commit "$miss" "" "$indent"
Jesse Greenwald915b9892010-11-09 22:18:36 -0600249 fi
250 done
251}
252
David Aguilard7fd7922016-07-27 17:16:50 -0700253set_notree () {
Jesse Greenwald915b9892010-11-09 22:18:36 -0600254 echo "1" > "$cachedir/notree/$1"
255}
256
David Aguilard7fd7922016-07-27 17:16:50 -0700257cache_set () {
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400258 oldrev="$1"
259 newrev="$2"
David Aguilar6ae6a232016-07-27 17:16:49 -0700260 if test "$oldrev" != "latest_old" &&
261 test "$oldrev" != "latest_new" &&
262 test -e "$cachedir/$oldrev"
263 then
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400264 die "cache for $oldrev already exists!"
265 fi
266 echo "$newrev" >"$cachedir/$oldrev"
267}
268
David Aguilard7fd7922016-07-27 17:16:50 -0700269rev_exists () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700270 if git rev-parse "$1" >/dev/null 2>&1
271 then
Avery Pennarun43a39512009-05-30 01:05:43 -0400272 return 0
273 else
274 return 1
275 fi
276}
277
David Aguilard7fd7922016-07-27 17:16:50 -0700278rev_is_descendant_of_branch () {
Jakub Suder0a562942010-01-09 19:56:05 +0100279 newrev="$1"
280 branch="$2"
David Aguilar6ae6a232016-07-27 17:16:49 -0700281 branch_hash=$(git rev-parse "$branch")
282 match=$(git rev-list -1 "$branch_hash" "^$newrev")
Jakub Suder0a562942010-01-09 19:56:05 +0100283
David Aguilar6ae6a232016-07-27 17:16:49 -0700284 if test -z "$match"
285 then
Jakub Suder0a562942010-01-09 19:56:05 +0100286 return 0
287 else
288 return 1
289 fi
290}
291
Avery Pennarunb9de5352009-04-25 00:06:45 -0400292# if a commit doesn't have a parent, this might not work. But we only want
293# to remove the parent from the rev-list, and since it doesn't exist, it won't
294# be there anyway, so do nothing in that case.
David Aguilard7fd7922016-07-27 17:16:50 -0700295try_remove_previous () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700296 if rev_exists "$1^"
297 then
Avery Pennarunb9de5352009-04-25 00:06:45 -0400298 echo "^$1^"
299 fi
300}
301
David Aguilard7fd7922016-07-27 17:16:50 -0700302find_latest_squash () {
Avery Pennarund713e2d2009-05-30 04:11:43 -0400303 debug "Looking for latest squash ($dir)..."
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400304 dir="$1"
Avery Pennarund713e2d2009-05-30 04:11:43 -0400305 sq=
306 main=
307 sub=
Avery Pennarun6f2012c2009-10-02 15:22:15 -0400308 git log --grep="^git-subtree-dir: $dir/*\$" \
Stephen R Guglielmo8841b522018-02-23 15:41:25 -0500309 --no-show-signature --pretty=format:'START %H%n%s%n%n%b%nEND%n' HEAD |
David Aguilar6ae6a232016-07-27 17:16:49 -0700310 while read a b junk
311 do
Avery Pennarund713e2d2009-05-30 04:11:43 -0400312 debug "$a $b $junk"
313 debug "{{$sq/$main/$sub}}"
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400314 case "$a" in
David Aguilar6ae6a232016-07-27 17:16:49 -0700315 START)
316 sq="$b"
317 ;;
318 git-subtree-mainline:)
319 main="$b"
320 ;;
321 git-subtree-split:)
322 sub="$(git rev-parse "$b^0")" ||
323 die "could not rev-parse split hash $b from commit $sq"
324 ;;
325 END)
326 if test -n "$sub"
327 then
328 if test -n "$main"
329 then
330 # a rejoin commit?
331 # Pretend its sub was a squash.
332 sq="$sub"
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400333 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700334 debug "Squash found: $sq $sub"
335 echo "$sq" "$sub"
336 break
337 fi
338 sq=
339 main=
340 sub=
341 ;;
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400342 esac
343 done
344}
345
David Aguilard7fd7922016-07-27 17:16:50 -0700346find_existing_splits () {
Avery Pennarun8b4a77f2009-04-24 16:48:08 -0400347 debug "Looking for prior splits..."
348 dir="$1"
349 revs="$2"
Avery Pennarund713e2d2009-05-30 04:11:43 -0400350 main=
351 sub=
Strain, Roger Ldd21d432018-09-28 13:35:38 -0500352 local grep_format="^git-subtree-dir: $dir/*\$"
353 if test -n "$ignore_joins"
354 then
355 grep_format="^Add '$dir/' from commit '"
356 fi
357 git log --grep="$grep_format" \
Stephen R Guglielmo8841b522018-02-23 15:41:25 -0500358 --no-show-signature --pretty=format:'START %H%n%s%n%n%b%nEND%n' $revs |
David Aguilar6ae6a232016-07-27 17:16:49 -0700359 while read a b junk
360 do
Avery Pennarun8b4a77f2009-04-24 16:48:08 -0400361 case "$a" in
David Aguilar6ae6a232016-07-27 17:16:49 -0700362 START)
363 sq="$b"
364 ;;
365 git-subtree-mainline:)
366 main="$b"
367 ;;
368 git-subtree-split:)
369 sub="$(git rev-parse "$b^0")" ||
370 die "could not rev-parse split hash $b from commit $sq"
371 ;;
372 END)
373 debug " Main is: '$main'"
374 if test -z "$main" -a -n "$sub"
375 then
376 # squash commits refer to a subtree
377 debug " Squash: $sq from $sub"
378 cache_set "$sq" "$sub"
379 fi
380 if test -n "$main" -a -n "$sub"
381 then
382 debug " Prior: $main -> $sub"
383 cache_set $main $sub
384 cache_set $sub $sub
385 try_remove_previous "$main"
386 try_remove_previous "$sub"
387 fi
388 main=
389 sub=
390 ;;
Avery Pennarun8b4a77f2009-04-24 16:48:08 -0400391 esac
392 done
393}
394
David Aguilard7fd7922016-07-27 17:16:50 -0700395copy_commit () {
Avery Pennarunf96bc792009-05-30 00:47:59 -0400396 # We're going to set some environment vars here, so
Avery Pennarunfd9500e2009-04-24 14:45:02 -0400397 # do it in a subshell to get rid of them safely later
Avery Pennaruna64f3a72009-04-26 16:53:57 -0400398 debug copy_commit "{$1}" "{$2}" "{$3}"
Stephen R Guglielmo8841b522018-02-23 15:41:25 -0500399 git log -1 --no-show-signature --pretty=format:'%an%n%ae%n%aD%n%cn%n%ce%n%cD%n%B' "$1" |
Avery Pennarunfd9500e2009-04-24 14:45:02 -0400400 (
401 read GIT_AUTHOR_NAME
402 read GIT_AUTHOR_EMAIL
403 read GIT_AUTHOR_DATE
404 read GIT_COMMITTER_NAME
405 read GIT_COMMITTER_EMAIL
406 read GIT_COMMITTER_DATE
Avery Pennarunb77172f2009-04-24 15:48:41 -0400407 export GIT_AUTHOR_NAME \
408 GIT_AUTHOR_EMAIL \
409 GIT_AUTHOR_DATE \
410 GIT_COMMITTER_NAME \
411 GIT_COMMITTER_EMAIL \
412 GIT_COMMITTER_DATE
David Aguilar6ae6a232016-07-27 17:16:49 -0700413 (
414 printf "%s" "$annotate"
415 cat
416 ) |
Avery Pennarunfd9500e2009-04-24 14:45:02 -0400417 git commit-tree "$2" $3 # reads the rest of stdin
418 ) || die "Can't copy commit $1"
419}
420
David Aguilard7fd7922016-07-27 17:16:50 -0700421add_msg () {
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400422 dir="$1"
423 latest_old="$2"
424 latest_new="$3"
David Aguilar6ae6a232016-07-27 17:16:49 -0700425 if test -n "$message"
426 then
Jakub Suder2da09692010-01-09 19:55:35 +0100427 commit_message="$message"
428 else
429 commit_message="Add '$dir/' from commit '$latest_new'"
430 fi
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400431 cat <<-EOF
Jakub Suder2da09692010-01-09 19:55:35 +0100432 $commit_message
David Aguilar6ae6a232016-07-27 17:16:49 -0700433
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400434 git-subtree-dir: $dir
435 git-subtree-mainline: $latest_old
436 git-subtree-split: $latest_new
437 EOF
438}
439
David Aguilard7fd7922016-07-27 17:16:50 -0700440add_squashed_msg () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700441 if test -n "$message"
442 then
Jakub Suder2da09692010-01-09 19:55:35 +0100443 echo "$message"
444 else
445 echo "Merge commit '$1' as '$2'"
446 fi
447}
448
David Aguilard7fd7922016-07-27 17:16:50 -0700449rejoin_msg () {
Avery Pennarunb77172f2009-04-24 15:48:41 -0400450 dir="$1"
451 latest_old="$2"
452 latest_new="$3"
David Aguilar6ae6a232016-07-27 17:16:49 -0700453 if test -n "$message"
454 then
Jakub Suder2da09692010-01-09 19:55:35 +0100455 commit_message="$message"
456 else
457 commit_message="Split '$dir/' into commit '$latest_new'"
458 fi
Avery Pennarunb77172f2009-04-24 15:48:41 -0400459 cat <<-EOF
Jakub Suder12629162010-01-12 22:38:34 +0100460 $commit_message
David Aguilar6ae6a232016-07-27 17:16:49 -0700461
Avery Pennarunb77172f2009-04-24 15:48:41 -0400462 git-subtree-dir: $dir
Avery Pennarun8b4a77f2009-04-24 16:48:08 -0400463 git-subtree-mainline: $latest_old
464 git-subtree-split: $latest_new
Avery Pennarunb77172f2009-04-24 15:48:41 -0400465 EOF
466}
467
David Aguilard7fd7922016-07-27 17:16:50 -0700468squash_msg () {
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400469 dir="$1"
470 oldsub="$2"
471 newsub="$3"
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400472 newsub_short=$(git rev-parse --short "$newsub")
David Aguilar6ae6a232016-07-27 17:16:49 -0700473
474 if test -n "$oldsub"
475 then
Avery Pennarund713e2d2009-05-30 04:11:43 -0400476 oldsub_short=$(git rev-parse --short "$oldsub")
477 echo "Squashed '$dir/' changes from $oldsub_short..$newsub_short"
478 echo
Stephen R Guglielmo8841b522018-02-23 15:41:25 -0500479 git log --no-show-signature --pretty=tformat:'%h %s' "$oldsub..$newsub"
480 git log --no-show-signature --pretty=tformat:'REVERT: %h %s' "$newsub..$oldsub"
Avery Pennarund713e2d2009-05-30 04:11:43 -0400481 else
482 echo "Squashed '$dir/' content from commit $newsub_short"
483 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700484
Avery Pennarund713e2d2009-05-30 04:11:43 -0400485 echo
486 echo "git-subtree-dir: $dir"
487 echo "git-subtree-split: $newsub"
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400488}
489
David Aguilard7fd7922016-07-27 17:16:50 -0700490toptree_for_commit () {
Avery Pennarun210d0832009-04-24 21:49:19 -0400491 commit="$1"
Stephen R Guglielmo8841b522018-02-23 15:41:25 -0500492 git rev-parse --verify "$commit^{tree}" || exit $?
Avery Pennarun210d0832009-04-24 21:49:19 -0400493}
494
David Aguilard7fd7922016-07-27 17:16:50 -0700495subtree_for_commit () {
Avery Pennarun210d0832009-04-24 21:49:19 -0400496 commit="$1"
497 dir="$2"
498 git ls-tree "$commit" -- "$dir" |
David Aguilar6ae6a232016-07-27 17:16:49 -0700499 while read mode type tree name
500 do
501 assert test "$name" = "$dir"
502 assert test "$type" = "tree" -o "$type" = "commit"
503 test "$type" = "commit" && continue # ignore submodules
Avery Pennarun768d6d12009-04-24 17:53:10 -0400504 echo $tree
505 break
506 done
507}
508
David Aguilard7fd7922016-07-27 17:16:50 -0700509tree_changed () {
Avery Pennarun768d6d12009-04-24 17:53:10 -0400510 tree=$1
511 shift
David Aguilar6ae6a232016-07-27 17:16:49 -0700512 if test $# -ne 1
513 then
Avery Pennarun768d6d12009-04-24 17:53:10 -0400514 return 0 # weird parents, consider it changed
515 else
Avery Pennarun210d0832009-04-24 21:49:19 -0400516 ptree=$(toptree_for_commit $1)
David Aguilar6ae6a232016-07-27 17:16:49 -0700517 if test "$ptree" != "$tree"
518 then
Avery Pennarun768d6d12009-04-24 17:53:10 -0400519 return 0 # changed
520 else
521 return 1 # not changed
522 fi
523 fi
524}
525
David Aguilard7fd7922016-07-27 17:16:50 -0700526new_squash_commit () {
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400527 old="$1"
528 oldsub="$2"
529 newsub="$3"
530 tree=$(toptree_for_commit $newsub) || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700531 if test -n "$old"
532 then
533 squash_msg "$dir" "$oldsub" "$newsub" |
534 git commit-tree "$tree" -p "$old" || exit $?
Avery Pennarund713e2d2009-05-30 04:11:43 -0400535 else
536 squash_msg "$dir" "" "$newsub" |
David Aguilar6ae6a232016-07-27 17:16:49 -0700537 git commit-tree "$tree" || exit $?
Avery Pennarund713e2d2009-05-30 04:11:43 -0400538 fi
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400539}
540
David Aguilard7fd7922016-07-27 17:16:50 -0700541copy_or_skip () {
Avery Pennarund6912652009-04-24 22:05:30 -0400542 rev="$1"
543 tree="$2"
544 newparents="$3"
David Aguilar6ae6a232016-07-27 17:16:49 -0700545 assert test -n "$tree"
Avery Pennarund6912652009-04-24 22:05:30 -0400546
Avery Pennarun96db2c02009-04-24 22:36:06 -0400547 identical=
Avery Pennarun49cf8222009-04-26 17:07:16 -0400548 nonidentical=
Avery Pennarun96db2c02009-04-24 22:36:06 -0400549 p=
Avery Pennaruna64f3a72009-04-26 16:53:57 -0400550 gotparents=
Strain, Roger L68f8ff82018-09-28 13:35:40 -0500551 copycommit=
David Aguilar6ae6a232016-07-27 17:16:49 -0700552 for parent in $newparents
553 do
Avery Pennarund6912652009-04-24 22:05:30 -0400554 ptree=$(toptree_for_commit $parent) || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700555 test -z "$ptree" && continue
556 if test "$ptree" = "$tree"
557 then
Avery Pennarun96db2c02009-04-24 22:36:06 -0400558 # an identical parent could be used in place of this rev.
Strain, Roger L68f8ff82018-09-28 13:35:40 -0500559 if test -n "$identical"
560 then
561 # if a previous identical parent was found, check whether
562 # one is already an ancestor of the other
563 mergebase=$(git merge-base $identical $parent)
564 if test "$identical" = "$mergebase"
565 then
566 # current identical commit is an ancestor of parent
567 identical="$parent"
568 elif test "$parent" != "$mergebase"
569 then
570 # no common history; commit must be copied
571 copycommit=1
572 fi
573 else
574 # first identical parent detected
575 identical="$parent"
576 fi
Avery Pennarun49cf8222009-04-26 17:07:16 -0400577 else
578 nonidentical="$parent"
Avery Pennarun96db2c02009-04-24 22:36:06 -0400579 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700580
Avery Pennaruna64f3a72009-04-26 16:53:57 -0400581 # sometimes both old parents map to the same newparent;
582 # eliminate duplicates
583 is_new=1
David Aguilar6ae6a232016-07-27 17:16:49 -0700584 for gp in $gotparents
585 do
586 if test "$gp" = "$parent"
587 then
Avery Pennaruna64f3a72009-04-26 16:53:57 -0400588 is_new=
589 break
590 fi
591 done
David Aguilar6ae6a232016-07-27 17:16:49 -0700592 if test -n "$is_new"
593 then
Avery Pennaruna64f3a72009-04-26 16:53:57 -0400594 gotparents="$gotparents $parent"
Avery Pennarund6912652009-04-24 22:05:30 -0400595 p="$p -p $parent"
596 fi
597 done
Dave Ware933cfeb2016-01-15 13:41:43 +1300598
David Aguilar6ae6a232016-07-27 17:16:49 -0700599 if test -n "$identical" && test -n "$nonidentical"
600 then
Dave Ware933cfeb2016-01-15 13:41:43 +1300601 extras=$(git rev-list --count $identical..$nonidentical)
David Aguilar6ae6a232016-07-27 17:16:49 -0700602 if test "$extras" -ne 0
603 then
Dave Ware933cfeb2016-01-15 13:41:43 +1300604 # we need to preserve history along the other branch
605 copycommit=1
606 fi
607 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700608 if test -n "$identical" && test -z "$copycommit"
609 then
Avery Pennarun96db2c02009-04-24 22:36:06 -0400610 echo $identical
611 else
David Aguilar6ae6a232016-07-27 17:16:49 -0700612 copy_commit "$rev" "$tree" "$p" || exit $?
Avery Pennarun96db2c02009-04-24 22:36:06 -0400613 fi
Avery Pennarund6912652009-04-24 22:05:30 -0400614}
615
David Aguilard7fd7922016-07-27 17:16:50 -0700616ensure_clean () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700617 if ! git diff-index HEAD --exit-code --quiet 2>&1
618 then
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400619 die "Working tree has modifications. Cannot add."
620 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700621 if ! git diff-index --cached HEAD --exit-code --quiet 2>&1
622 then
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400623 die "Index has modifications. Cannot add."
624 fi
Avery Pennarun13648af2009-04-24 23:41:19 -0400625}
626
David Aguilard7fd7922016-07-27 17:16:50 -0700627ensure_valid_ref_format () {
Anthony Baire1c3e0f02013-11-27 19:34:09 +0100628 git check-ref-format "refs/heads/$1" ||
David Aguilar6ae6a232016-07-27 17:16:49 -0700629 die "'$1' does not look like a ref"
Anthony Baire1c3e0f02013-11-27 19:34:09 +0100630}
631
Strain, Roger L565e4b72018-09-28 13:35:37 -0500632process_split_commit () {
633 local rev="$1"
634 local parents="$2"
Strain, Roger L315a84f2018-09-28 13:35:39 -0500635 local indent=$3
636
637 if test $indent -eq 0
638 then
639 revcount=$(($revcount + 1))
640 else
641 # processing commit without normal parent information;
642 # fetch from repo
Roger Strain19ad68d2018-10-12 08:52:18 -0500643 parents=$(git rev-parse "$rev^@")
Strain, Roger L315a84f2018-09-28 13:35:39 -0500644 extracount=$(($extracount + 1))
645 fi
646
647 progress "$revcount/$revmax ($createcount) [$extracount]"
648
Strain, Roger L565e4b72018-09-28 13:35:37 -0500649 debug "Processing commit: $rev"
650 exists=$(cache_get "$rev")
651 if test -n "$exists"
652 then
653 debug " prior: $exists"
654 return
655 fi
656 createcount=$(($createcount + 1))
657 debug " parents: $parents"
Strain, Roger L315a84f2018-09-28 13:35:39 -0500658 check_parents "$parents" "$indent"
Strain, Roger L565e4b72018-09-28 13:35:37 -0500659 newparents=$(cache_get $parents)
660 debug " newparents: $newparents"
661
662 tree=$(subtree_for_commit "$rev" "$dir")
663 debug " tree is: $tree"
664
Strain, Roger L565e4b72018-09-28 13:35:37 -0500665 # ugly. is there no better way to tell if this is a subtree
666 # vs. a mainline commit? Does it matter?
667 if test -z "$tree"
668 then
669 set_notree "$rev"
670 if test -n "$newparents"
671 then
672 cache_set "$rev" "$rev"
673 fi
674 return
675 fi
676
677 newrev=$(copy_or_skip "$rev" "$tree" "$newparents") || exit $?
678 debug " newrev is: $newrev"
679 cache_set "$rev" "$newrev"
680 cache_set latest_new "$newrev"
681 cache_set latest_old "$rev"
682}
683
David Aguilard7fd7922016-07-27 17:16:50 -0700684cmd_add () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700685 if test -e "$dir"
686 then
Avery Pennarun13648af2009-04-24 23:41:19 -0400687 die "'$dir' already exists. Cannot add."
688 fi
Wayne Walterc00d1d12010-02-13 14:32:21 -0500689
Avery Pennarun13648af2009-04-24 23:41:19 -0400690 ensure_clean
David A. Greene10a49582013-02-04 22:06:03 -0600691
David Aguilar6ae6a232016-07-27 17:16:49 -0700692 if test $# -eq 1
693 then
694 git rev-parse -q --verify "$1^{commit}" >/dev/null ||
695 die "'$1' does not refer to a commit"
David A. Greene10a49582013-02-04 22:06:03 -0600696
David Aguilar6ae6a232016-07-27 17:16:49 -0700697 cmd_add_commit "$@"
698
699 elif test $# -eq 2
700 then
701 # Technically we could accept a refspec here but we're
702 # just going to turn around and add FETCH_HEAD under the
703 # specified directory. Allowing a refspec might be
704 # misleading because we won't do anything with any other
705 # branches fetched via the refspec.
706 ensure_valid_ref_format "$2"
707
708 cmd_add_repository "$@"
Wayne Walterc00d1d12010-02-13 14:32:21 -0500709 else
David Aguilar6ae6a232016-07-27 17:16:49 -0700710 say "error: parameters were '$@'"
711 die "Provide either a commit or a repository and commit."
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400712 fi
Wayne Walterc00d1d12010-02-13 14:32:21 -0500713}
714
David Aguilard7fd7922016-07-27 17:16:50 -0700715cmd_add_repository () {
Wayne Walterc00d1d12010-02-13 14:32:21 -0500716 echo "git fetch" "$@"
717 repository=$1
718 refspec=$2
719 git fetch "$@" || exit $?
720 revs=FETCH_HEAD
721 set -- $revs
722 cmd_add_commit "$@"
723}
724
David Aguilard7fd7922016-07-27 17:16:50 -0700725cmd_add_commit () {
Denton Liu77128ed2019-03-11 02:47:17 -0700726 rev=$(git rev-parse $default --revs-only "$@") || exit $?
727 ensure_single_rev $rev
David Aguilar6ae6a232016-07-27 17:16:49 -0700728
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400729 debug "Adding $dir as '$rev'..."
730 git read-tree --prefix="$dir" $rev || exit $?
Avery Pennarun227f7812009-08-26 10:43:43 -0400731 git checkout -- "$dir" || exit $?
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400732 tree=$(git write-tree) || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700733
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400734 headrev=$(git rev-parse HEAD) || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700735 if test -n "$headrev" && test "$headrev" != "$rev"
736 then
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400737 headp="-p $headrev"
738 else
739 headp=
740 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700741
742 if test -n "$squash"
743 then
Avery Pennarund713e2d2009-05-30 04:11:43 -0400744 rev=$(new_squash_commit "" "" "$rev") || exit $?
Jakub Suder2da09692010-01-09 19:55:35 +0100745 commit=$(add_squashed_msg "$rev" "$dir" |
David Aguilar6ae6a232016-07-27 17:16:49 -0700746 git commit-tree "$tree" $headp -p "$rev") || exit $?
Avery Pennarund713e2d2009-05-30 04:11:43 -0400747 else
James Denholm6f1871f2014-05-13 14:08:58 +1000748 revp=$(peel_committish "$rev") &&
David Aguilar6ae6a232016-07-27 17:16:49 -0700749 commit=$(add_msg "$dir" $headrev "$rev" |
750 git commit-tree "$tree" $headp -p "$revp") || exit $?
Avery Pennarund713e2d2009-05-30 04:11:43 -0400751 fi
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400752 git reset "$commit" || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700753
Avery Pennarund713e2d2009-05-30 04:11:43 -0400754 say "Added dir '$dir'"
Avery Pennaruneb7b5902009-04-24 23:28:30 -0400755}
756
David Aguilard7fd7922016-07-27 17:16:50 -0700757cmd_split () {
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400758 debug "Splitting $dir..."
759 cache_setup || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700760
761 if test -n "$onto"
762 then
Avery Pennarun847e8682009-04-24 21:35:50 -0400763 debug "Reading history for --onto=$onto..."
Avery Pennarun33ff5832009-04-24 17:05:14 -0400764 git rev-list $onto |
David Aguilar6ae6a232016-07-27 17:16:49 -0700765 while read rev
766 do
Avery Pennarun33ff5832009-04-24 17:05:14 -0400767 # the 'onto' history is already just the subdir, so
768 # any parent we find there can be used verbatim
Avery Pennarun2c71b7c2009-04-24 17:42:33 -0400769 debug " cache: $rev"
David Aguilar6ae6a232016-07-27 17:16:49 -0700770 cache_set "$rev" "$rev"
Avery Pennarun33ff5832009-04-24 17:05:14 -0400771 done
772 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700773
Strain, Roger Ldd21d432018-09-28 13:35:38 -0500774 unrevs="$(find_existing_splits "$dir" "$revs")"
David Aguilar6ae6a232016-07-27 17:16:49 -0700775
Avery Pennarun1f738622009-04-26 15:54:42 -0400776 # We can't restrict rev-list to only $dir here, because some of our
777 # parents have the $dir contents the root, and those won't match.
778 # (and rev-list --follow doesn't seem to solve this)
Jesse Greenwald6f4f84f2010-11-09 08:34:49 -0600779 grl='git rev-list --topo-order --reverse --parents $revs $unrevs'
Avery Pennarun942dce52009-04-26 18:06:08 -0400780 revmax=$(eval "$grl" | wc -l)
781 revcount=0
782 createcount=0
Strain, Roger L315a84f2018-09-28 13:35:39 -0500783 extracount=0
Avery Pennarun942dce52009-04-26 18:06:08 -0400784 eval "$grl" |
David Aguilar6ae6a232016-07-27 17:16:49 -0700785 while read rev parents
786 do
Strain, Roger L315a84f2018-09-28 13:35:39 -0500787 process_split_commit "$rev" "$parents" 0
Avery Pennarun25733542009-04-24 14:24:38 -0400788 done || exit $?
David Aguilar6ae6a232016-07-27 17:16:49 -0700789
Avery Pennarunb77172f2009-04-24 15:48:41 -0400790 latest_new=$(cache_get latest_new)
David Aguilar6ae6a232016-07-27 17:16:49 -0700791 if test -z "$latest_new"
792 then
Avery Pennarune25a6bf2009-04-24 14:52:27 -0400793 die "No new revisions were found"
794 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700795
796 if test -n "$rejoin"
797 then
Avery Pennarunb77172f2009-04-24 15:48:41 -0400798 debug "Merging split branch into HEAD..."
799 latest_old=$(cache_get latest_old)
800 git merge -s ours \
David Aguilar0f12c7d2016-07-25 21:14:15 -0700801 --allow-unrelated-histories \
David Aguilar6ae6a232016-07-27 17:16:49 -0700802 -m "$(rejoin_msg "$dir" "$latest_old" "$latest_new")" \
803 "$latest_new" >&2 || exit $?
Avery Pennarunb77172f2009-04-24 15:48:41 -0400804 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700805 if test -n "$branch"
806 then
807 if rev_exists "refs/heads/$branch"
808 then
809 if ! rev_is_descendant_of_branch "$latest_new" "$branch"
810 then
Jakub Suder0a562942010-01-09 19:56:05 +0100811 die "Branch '$branch' is not an ancestor of commit '$latest_new'."
812 fi
813 action='Updated'
814 else
815 action='Created'
816 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700817 git update-ref -m 'subtree split' \
818 "refs/heads/$branch" "$latest_new" || exit $?
Jakub Suder0a562942010-01-09 19:56:05 +0100819 say "$action branch '$branch'"
Avery Pennarun43a39512009-05-30 01:05:43 -0400820 fi
David Aguilar6ae6a232016-07-27 17:16:49 -0700821 echo "$latest_new"
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400822 exit 0
823}
824
David Aguilard7fd7922016-07-27 17:16:50 -0700825cmd_merge () {
Denton Liu77128ed2019-03-11 02:47:17 -0700826 rev=$(git rev-parse $default --revs-only "$@") || exit $?
827 ensure_single_rev $rev
Avery Pennarun13648af2009-04-24 23:41:19 -0400828 ensure_clean
David Aguilar6ae6a232016-07-27 17:16:49 -0700829
David Aguilar6ae6a232016-07-27 17:16:49 -0700830 if test -n "$squash"
831 then
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400832 first_split="$(find_latest_squash "$dir")"
David Aguilar6ae6a232016-07-27 17:16:49 -0700833 if test -z "$first_split"
834 then
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400835 die "Can't squash-merge: '$dir' was never added."
836 fi
837 set $first_split
838 old=$1
839 sub=$2
David Aguilar6ae6a232016-07-27 17:16:49 -0700840 if test "$sub" = "$rev"
841 then
Avery Pennaruneb4fb912009-05-30 03:33:17 -0400842 say "Subtree is already at commit $rev."
843 exit 0
844 fi
Avery Pennarun1cc2cff2009-05-30 03:18:27 -0400845 new=$(new_squash_commit "$old" "$sub" "$rev") || exit $?
846 debug "New squash commit: $new"
847 rev="$new"
848 fi
Pelle Wessman448e71e2010-05-07 21:21:25 +0200849
850 version=$(git version)
David Aguilar6ae6a232016-07-27 17:16:49 -0700851 if test "$version" \< "git version 1.7"
852 then
853 if test -n "$message"
854 then
855 git merge -s subtree --message="$message" "$rev"
Pelle Wessman448e71e2010-05-07 21:21:25 +0200856 else
David Aguilar6ae6a232016-07-27 17:16:49 -0700857 git merge -s subtree "$rev"
Pelle Wessman448e71e2010-05-07 21:21:25 +0200858 fi
Avery Pennarun349a70d2010-02-06 15:05:17 -0500859 else
David Aguilar6ae6a232016-07-27 17:16:49 -0700860 if test -n "$message"
861 then
862 git merge -Xsubtree="$prefix" \
863 --message="$message" "$rev"
Pelle Wessman448e71e2010-05-07 21:21:25 +0200864 else
865 git merge -Xsubtree="$prefix" $rev
866 fi
Avery Pennarun349a70d2010-02-06 15:05:17 -0500867 fi
Avery Pennarun0ca71b32009-04-24 14:13:34 -0400868}
869
David Aguilard7fd7922016-07-27 17:16:50 -0700870cmd_pull () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700871 if test $# -ne 2
872 then
873 die "You must provide <repository> <ref>"
Anthony Baire1c3e0f02013-11-27 19:34:09 +0100874 fi
Avery Pennarun13648af2009-04-24 23:41:19 -0400875 ensure_clean
Anthony Baire1c3e0f02013-11-27 19:34:09 +0100876 ensure_valid_ref_format "$2"
Avery Pennarune31d1e22009-10-02 18:23:54 -0400877 git fetch "$@" || exit $?
878 revs=FETCH_HEAD
Wayne Walterc00d1d12010-02-13 14:32:21 -0500879 set -- $revs
880 cmd_merge "$@"
881}
882
David Aguilard7fd7922016-07-27 17:16:50 -0700883cmd_push () {
David Aguilar6ae6a232016-07-27 17:16:49 -0700884 if test $# -ne 2
885 then
886 die "You must provide <repository> <ref>"
Wayne Walterc00d1d12010-02-13 14:32:21 -0500887 fi
Anthony Baire1c3e0f02013-11-27 19:34:09 +0100888 ensure_valid_ref_format "$2"
David Aguilar6ae6a232016-07-27 17:16:49 -0700889 if test -e "$dir"
890 then
891 repository=$1
892 refspec=$2
893 echo "git push using: " "$repository" "$refspec"
894 localrev=$(git subtree split --prefix="$prefix") || die
895 git push "$repository" "$localrev":"refs/heads/$refspec"
Wayne Walterc00d1d12010-02-13 14:32:21 -0500896 else
David Aguilar6ae6a232016-07-27 17:16:49 -0700897 die "'$dir' must already exist. Try 'git subtree add'."
Wayne Walterc00d1d12010-02-13 14:32:21 -0500898 fi
Avery Pennarun13648af2009-04-24 23:41:19 -0400899}
900
901"cmd_$command" "$@"